import * as line from "@line/bot-sdk";
import LineNotify from "./LineNotify";

/**
 * MemberJoined
 */
export default class MemberJoinedClass {

	//#region private

	private bot: line.Client = null;

	//#endregion

	//#region Lifecycle

	constructor(bot: line.Client) {
		this.bot = bot;
	}

	//#endregion

	//#region Custom

	public async MemberJoined(event: any): Promise<void> {
		switch (event.source.groupId) {
			case process.env.toBadminton: {
				this.badminton_MemberJoin(event);
				break;
			}

			default:
				break;
		}
	}

	private async badminton_MemberJoin(event: any): Promise<void> {
		const members: any[] = event.joined.members;
		for (let i: number = 0; i < members.length; i++) {
			const userId: string = members[i].userId;
			this.sendBadminton_Welcome(event, event.source.groupId, userId);
		}
	}

	private async sendBadminton_Welcome(event: any, groupId: string, userId: string): Promise<void> {
		const userdata: line.Profile = await this.bot.getGroupMemberProfile(groupId, userId);
		if (userdata && userdata.displayName) {
			const message: string = `歡迎尊貴的 ${userdata.displayName} 降臨羽球團`;
			event.reply(message);
			LineNotify.SendBadmintonNotify();
		}
	}

	//#endregion
}
