import * as line from "@line/bot-sdk";
import OpenAI from "./OpenAI";

/**
 * Message
 */
export default class MessageClass {

	//#region private

	private bot: line.Client = null;

	//#endregion

	//#region Lifecycle

	constructor(bot: line.Client) {
		this.bot = bot;
	}

	//#endregion

	//#region Custom

	public async Message(event: any): Promise<void> {
		switch (event.message.type) {
			case "text": {
				return await this.Text(event);
			}

			case "sticker": {
				return await this.Sticker(event);
			}

			default:
				break;
		}
	}

	public async Text(event: any): Promise<void> {
		switch (event.source.type) {
			case "user": {
				return await this.User(event);
			}

			case "group":
			default:
				break;
		}
	}

	public async Sticker(event: any): Promise<any> {
		switch (event.source.type) {
			case "user": {
				let replyMsg: string = `https://liff.line.me/1657715144-m4W6lyjL?type=sticker&stk=noanim&sid=${event.message.stickerId}&pkg=${event.message.packageId}`;
				const resp: line.Message = {
					type: "text",
					text: replyMsg
				};
				return this.bot.replyMessage(event.replyToken, resp);
			}

			case "group":
			default: {
				return Promise.resolve(null);
			}
		}
	}

	public async User(event: any): Promise<any> {
		let userId = event.source.userId;
		let replyMsg = event.message.text;
		// let displayName = "";
		// let profile = await this.bot.getProfile(userId);
		// if (profile) {
		// 	displayName = profile.displayName;
		// }
		// 豬喵 特別功能
		if ([process.env.toJianMiau, process.env.toZhuHan].includes(userId)) {
			const response: string = await OpenAI.RunOpenAI(replyMsg);
			replyMsg = response;
		}
		// 	/** 訊息 */
		// 	let Msg = event.message.text.split(" ");

		// 	/** 指令 */
		// 	let Instruction = Msg[0];
		// 	switch (Instruction) {
		// 		case "msg":
		// 		case "Msg":
		// 		case "MSG": {
		// 			if (userId == process.env.toJianMiau) {
		// 				replyMsg = "";
		// 				if (Msg[1] === "豬涵") {
		// 					if (Msg[2] === "豬涵") {
		// 						Msg[2] = process.env.toZhuHantoZhuHan;
		// 					} else if (Msg[2] === "建喵") {
		// 						Msg[2] = process.env.toZhuHantoJianMiau;
		// 					}
		// 					for (let i = 3; i < Msg.length; i++) {
		// 						replyMsg += Msg[i] + (i === Msg.length - 1 ? "" : " ");
		// 					}
		// 					let res_Msg = this.ZhuHanbot.push(Msg[2], replyMsg);
		// 				} else {
		// 					for (let i = 3; i < Msg.length; i++) {
		// 						replyMsg += Msg[i] + (i === Msg.length - 1 ? "" : " ");
		// 					}
		// 					let res_Msg = this.bot.push(Msg[2], replyMsg);
		// 				}

		// 				let ToJM_message = "已發送訊息:";
		// 				ToJM_message += `\nMyId: ${Msg[1]}`;
		// 				ToJM_message += `\nuserId: ${Msg[2]}`;
		// 				ToJM_message += `\nmessage: ${replyMsg}`;
		// 				let res_reply = event.reply(ToJM_message).then(function (data) {
		// 					// 當訊息成功回傳後的處理
		// 				}).catch(function (error) {
		// 					// 當訊息回傳失敗後的處理
		// 				});
		// 			}
		// 			break;
		// 		}

		// 		default: {
		// 			// 使用event.reply(要回傳的訊息)方法可將訊息回傳給使用者
		// 			event.reply(replyMsg).then(function (data) {
		// 				// 當訊息成功回傳後的處理
		// 			}).catch(function (error) {
		// 				// 當訊息回傳失敗後的處理
		// 			});
		// 			break;
		// 		}
		// 	}
		// }
		return this.bot.replyMessage(event.replyToken, {
			type: "text",
			text: replyMsg
		});
		// return this.bot.replyMessage(event.replyToken, {
		// 	type: "text",
		// 	text: event.message.text
		// });
	}

	// Group(event) {
	// 	switch (event.source.groupId) {
	// 		case process.env.toYoutube: {
	// 			let messagereplace = event.message.text;
	// 			messagereplace.replace("【IFTTT】 \n", "");
	// 			let replyMsg = messagereplace;
	// 			let res_toUniversity = this.bot.pushMessage(process.env.toUniversity, replyMsg);
	// 			let res_toApex = this.bot.pushMessage(process.env.toApex, replyMsg);
	// 			break;
	// 		}

	// 		default:
	// 			break;
	// 	}
	// }

	//#endregion
}
