import { Configuration, CreateCompletionResponseChoicesInner, OpenAIApi } from "openai";

/**
 * OpenAI
 */
export default class OpenAI {

	//#region Custom

	public static async RunOpenAI(msg: string): Promise<string> {
		const configuration = new Configuration({
			apiKey: process.env.OPENAI_API_KEY,
		});
		const openai = new OpenAIApi(configuration);
		const response = await openai.createCompletion({
			model: "text-davinci-003",
			prompt: msg,
			temperature: 0.7,
			max_tokens: 256,
			top_p: 1,
			frequency_penalty: 0,
			presence_penalty: 0,
		});
		let resptext: string = msg;
		const choices = response.data.choices;
		for (let i = 0; i < choices.length; i++) {
			const choice: CreateCompletionResponseChoicesInner = choices[i];
			resptext += choice.text;
		}
		return resptext;
	}

	//#endregion
}
